`timescale 1ns/1ns
`define NULL 0
`define MAX_LINE 256
`define EOF 32'hffff_ffff

/* Read a test file with binary data */
module test2;
   integer 	filein,r;
   reg 		r1;
   reg [ 7:0] 	r8;

   initial
     begin
	$monitor("@%0d r1=%b, r8=%b, line=%0d", $stime,r1,r8,r);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading packed bin file, regs in $getpat_open");
	filein = $getpat_open("test2.pbin", "b", r1,r8);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Reading packed bin file, regs in $getpat_next");
	filein = $getpat_open("test2.pbin", "b");

	/* Loop through the file */
	r = $getpat_next(filein, r1,r8);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r1,r8);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced bin file, regs in $getpat_open");
	filein = $getpat_open("test2.sbin", "b ", r8,r1);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced bin file, regs in $getpat_next");
	filein = $getpat_open("test2.sbin", "b ");

	/* Loop through the file */
	r = $getpat_next(filein, r8,r1);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r8,r1);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the packed Hex file, regs in $getpat_open");
	filein = $getpat_open("test2.phex", "h", r8, r1);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the packed Hex file, regs in $getpat_next");
	filein = $getpat_open("test2.phex", "h");

	/* Loop through the file */
	r = $getpat_next(filein, r8, r1);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r8, r1);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced Hex file, regs in $getpat_open");
	filein = $getpat_open("test2.shex", "h ", r8, r1);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced Hex file, regs in $getpat_next");
	filein = $getpat_open("test2.shex", "h ");

	/* Loop through the file */
	r = $getpat_next(filein, r8, r1);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r8, r1);
	  end
	#1 $getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the packed hex file, regs in $getpat_open");
	filein = $getpat_open("test2.phex", "x", r8, r1);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the packed hex file, regs in $getpat_next");
	filein = $getpat_open("test2.phex", "x");

	/* Loop through the file */
	r = $getpat_next(filein, r8, r1);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r8, r1);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced hex file, regs in $getpat_open");
	filein = $getpat_open("test2.shex", "x ", r8, r1);

	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading the spaced hex file, regs in $getpat_next");
	filein = $getpat_open("test2.shex", "x ");

	/* Loop through the file */
	r = $getpat_next(filein, r8, r1);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r8, r1);
	  end
	#1 $getpat_close(filein);

	$finish;
     end

endmodule
