`timescale 1ns/1ns
`define EOF 32'hffff_ffff

module test3;
   
   integer 	filein,r;
   reg [ 3:0]	r4;
   reg [31:0] 	r32;
   reg [1000:0] r1000;
   

   initial
     begin
	$monitor("@%0d r4=%d, r32=%d, line=%0d", $stime,r4,r32,r);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading first file, default format, regs in $getpat_open");
	filein = $getpat_open("test3.dec", r4,r32);
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	
	$display("\n\n------------------------------------------------------------------------");
	$display("Reading first file, default format, regs in $getpat_next");
	filein = $getpat_open("test3.dec");
	r = $getpat_next(filein, r4,r32);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r4,r32);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Reading second file, \"d\" format, regs in $getpat_open");
	filein = $getpat_open("test3.dec", "d", r4,r32);
	/* Loop through the file */
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	
	$display("\n\n------------------------------------------------------------------------");
	$display("Reading second file, \"d\" format, regs in $getpat_next");
	filein = $getpat_open("test3.dec", "d");
	/* Loop through the file */
	r = $getpat_next(filein, r4,r32);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r4,r32);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Reading third file, \"d \" format, regs in $getpat_open");
	filein = $getpat_open("test3.dec", "d ", r4,r32);
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Reading third file, \"d \" format, regs in $getpat_next");
	filein = $getpat_open("test3.dec", "d ");
	r = $getpat_next(filein, r4,r32);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r4,r32);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
     	$display("Reading third file, wide decimal format, regs in $getpat_open");
	filein = $getpat_open("test3.wide", "d ", r1000);
	$monitor("%0d",r1000);
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
     	$display("Reading third file, wide decimal format, regs in $getpat_next");
	filein = $getpat_open("test3.wide", "d ");
	$monitor("%0d",r1000);
	r = $getpat_next(filein, r1000);
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein, r1000);
	  end
	#1 $getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("All done with decimal data");
	
	$finish;
     end

endmodule // test3

