`timescale 1ns/1ns
`define NULL 0
`define MAX_LINE 256
`define EOF 32'hffff_ffff

/* Get lots of error messages */
module test7;
   integer 	filein, r, r32, s32;
   reg 		r1;
   reg [ 7:0] 	r8, s8;
   reg [ 8:0] 	r9;
   reg [ 9:0] 	r10;
   reg [10:0] 	r11;
   reg [11:0] 	r12, r13, r14;

   initial
     begin
	$display("***This test will cause a lot of errors which is fine***");
	$display("It tests reading unpacked data - separated by a space");


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_open");
	$display("This will cause warnings");
	filein = $getpat_open("test7.hex6", "h ", r8, r9, r10, r11, r12, r32);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_next");
	$display("This will cause warnings");
	filein = $getpat_open("test7.hex6", "h ");

	// Loop through the file
	r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);




	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_open");
	$display("Now call $getpat_options(\"ignore_truncate\");");
	$getpat_options("ignore_truncate");
	$display("This will not cause warnings");
	filein = $getpat_open("test7.hex6", "h ", r8, r9, r10, r11, r12, r32);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_next");
	$display("This will cause warnings");
	filein = $getpat_open("test7.hex6", "h ");

	// Loop through the file
	r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_open");
	$display("This will cause warnings");
	$display("Now call $getpat_options(\"warn_truncate\");");
	$display("This will cause warnings");
	$getpat_options("warn_truncate");
	filein = $getpat_open("test7.hex6", "h ", r8, r9, r10, r11, r12, r32);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too wide");
	$display("Registers in $getpat_next");
	$display("This will cause warnings");
	filein = $getpat_open("test7.hex6", "h ");

	// Loop through the file
	r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	while (r != `EOF)
	  begin
	     #1 $display("r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	     r = $getpat_next(filein, r8, r9, r10, r11, r12, r32);
	  end
	#1 $display("Final r8=%h, r9=%h, r10=%h, r11=%h, r12=%h, r32=%h", r8, r9, r10, r11, r12, r32);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too narrow");
	$display("Registers in $getpat_open");
	$display("This will not cause errors");

	filein = $getpat_open("test7.hex3", "h ", r12, r32, s32);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r32, s32);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r32, s32);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where data is too narrow");
	$display("Registers in $getpat_next");
	$display("This will not cause errors");
	filein = $getpat_open("test7.hex3", "h ");

	// Loop through the file
	r = $getpat_next(filein, r12, r32, s32);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r32, s32);
	     r = $getpat_next(filein, r12, r32, s32);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r32, s32);
	$getpat_close(filein);









	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too many values");
	$display("Registers in $getpat_open");
	filein = $getpat_open("test7.long", "h ", r12, r13, r14);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too many values");
	$display("Registers in $getpat_next");
	filein = $getpat_open("test7.long", "h ");

	// Loop through the file
	r = $getpat_next(filein, r12, r13, r14);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein, r12, r13, r14);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too few values because of newline");
	$display("Registers in $getpat_open");
	filein = $getpat_open("test7.short_nl", "h ", r12, r13, r14);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too few values because of newline");
	$display("Registers in $getpat_next");
	filein = $getpat_open("test7.short_nl", "h ");

	// Loop through the file
	r = $getpat_next(filein, r12, r13, r14);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein, r12, r13, r14);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too few values because of comment");
	$display("Registers in $getpat_open");
	filein = $getpat_open("test7.short_cmt", "h ", r12, r13, r14);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where an intermediate line has too few values because of comment");
	$display("Registers in $getpat_next");
	filein = $getpat_open("test7.short_cmt", "h ");

	// Loop through the file
	r = $getpat_next(filein, r12, r13, r14);
	while (r != `EOF)
	  begin
	     #1 $display("r = %h, %h, %h", r12, r13, r14);
	     r = $getpat_next(filein, r12, r13, r14);
	  end
	#1 $display("Final r = %h, %h, %h", r12, r13, r14);
	$getpat_close(filein);



	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where the last line comes up short");
	$display("Registers in $getpat_open");
	filein = $getpat_open("test7.short_eof", "h ", r12, r13);

	// Loop through the file
	r = $getpat_next(filein);
	while (r != `EOF)
	  begin
	     #1 $display("r12=%h, r13=%h", r12, r13);
	     r = $getpat_next(filein);
	  end
	#1 $display("Final final r12=%h, r13=%h", r12, r13);
	$getpat_close(filein);


	$display("\n\n------------------------------------------------------------------------");
	$display("Read a spaced hex where the last line comes up short");
	$display("Registers in $getpat_next");
	filein = $getpat_open("test7.short_eof", "h ");

	// Loop through the file
	r = $getpat_next(filein, r12, r13);
	while (r != `EOF)
	  begin
	     #1 $display("r12=%h, r13=%h", r12, r13);
	     r = $getpat_next(filein, r12, r13);
	  end
	#1 $display("Final final r12=%h, r13=%h", r12, r13);
	$getpat_close(filein);

	$display("\n\n------------------------------------------------------------------------");
	$display("The end - at last!");
	$display("\n\n------------------------------------------------------------------------");

	$finish;
     end

endmodule
