`timescale 1ns/1ns
`define NULL 0
`define MAX_LINE 256
`define EOF 32'hffff_ffff

module test9;
   integer 	filein,r;
   reg 		r1;
   reg [ 7:0] 	r8, s8;
   reg [11:0] 	r12, r13;
 	
   initial
     begin
	$display("***This test will cause a lot of errors which is fine***");
	$display("It concentrates on everything but actually reading data");
	
	// ERROR: Try to open a non-existant file
	$display("\n\n------------------------------------------------------------------------");
	$display("Reading a non-existant file");

	filein = $getpat_open("none.such", "b ", r8,r1);  // Verified
	$display("$getpat_open returned %d", filein);

	// Loop through the file
	r = $getpat_next(filein);  // Verified
	while (r != `EOF)
	  begin
	     #1 r = $getpat_next(filein);
	  end
	#1 $getpat_close(filein);  // Verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Try a filenum of 0");
	filein = 0;
	r = $getpat_next(filein);  // Verified
	$getpat_close(filein);  // Verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Try a filenum of -1");
	filein = -1;
	r = $getpat_next(filein);  // Verified
	$getpat_close(filein);  // Verified


	// ERROR: Don't use regs in open or next
	$display("\n\n------------------------------------------------------------------------");
	$display("Get an error because no reg specified, w/o fmt");
	filein = $getpat_open("test9.dec");
	r = $getpat_next(filein);  // Verified
	$getpat_close(filein);



	// ERROR: Don't use regs in open or next
	$display("\n\n------------------------------------------------------------------------");
	$display("Get an error because no reg specified, w/fmt");
	filein = $getpat_open("test9.dec", "d");
	r = $getpat_next(filein);  // Verified
	$getpat_close(filein);



	// ERROR: Use regs in both open and next
	#10
	  $display("\n\n------------------------------------------------------------------------");
	$display("Get an error because too many regs specified, w/o fmt");
	filein = $getpat_open("test9.dec", r8);
	r = $getpat_next(filein, r8);  // Verified
	$getpat_close(filein);


	// ERROR: Use regs in both open and next
	#10
	  $display("\n\n------------------------------------------------------------------------");
	$display("Get an error because too many regs specified, w/fmt");
	filein = $getpat_open("test9.dec", "d", r8);
	r = $getpat_next(filein, r8);  // Verified
	$getpat_close(filein);


	// ERROR: Try botching up the arguments
	$display("\n\n------------------------------------------------------------------------");
	$display("Leave out the file name argument in $getpat_open");
	filein = $getpat_open;  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Use null file name argument in $getpat_open");
	filein = $getpat_open();  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Leave out the file number argument in $getpat_next");
	r = $getpat_next;  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Use null file number argument in $getpat_next");
	r = $getpat_next();  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Leave out the file number argument in $getpat_close");
	$getpat_close;  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Use null file number argument in $getpat_close");
	$getpat_close();  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Wrong types for file name argument in $getpat_open");
	filein = $getpat_open(r8);  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Wrong types for filein argument in $getpat_next");
	filein = $getpat_next(0);  // Verified

	$display("\n\n------------------------------------------------------------------------");
	$display("Wrong types for filein argument in $getpat_close");
	$getpat_close(0);  // Verified


	$display("\n\n------------------------------------------------------------------------");
	$display("Use a bad radix - this will fail");
	r = $getpat_open("test9.dec", "q");


	$display("\n\n------------------------------------------------------------------------");
	$display("Use a good radix and a bad separator - this will fail");
	r = $getpat_open("test9.dec", "hq");


	$display("\n\n------------------------------------------------------------------------");
	$display("Use a bad radix and separator - this will fail");
	r = $getpat_open("test9.dec", "qr");


	$display("\n\n------------------------------------------------------------------------");
	$display("The end - at last!");
	$display("\n\n------------------------------------------------------------------------");


	$finish;
     end

endmodule
